{{
        RIC_XBee
        Interface object for an XBee.  Currently only supports transparent mode.
                1x XBee Module
}}

CON


VAR

  Byte                          arrBuffer[120]

OBJ

  objXBee                       : "FullDuplexSerial"
  objTime                       : "Timing"


PUB Initialize (pin_rx, pin_tx, mode, baud)
{{
    Initializes the XBee module and any other required objects
      XBee is intialized to have a 100ms pause requirement before and after a +++ command
      Subroutine ends with RX buffer flushed clean
}}

  'INIT FULLDUPLEXSERIAL FOR XBEE
  objXBee.start (pin_rx, pin_tx, mode, baud)
  'CONFIGURE THE XBEE
  objXBee.Str(string("+++"))
  objTime.Pause1ms (2000)
  objXBee.Str(string("ATGT 3,CN"))
  objXBee.TX(13)
  objTime.Pause1ms (500)
  objXBee.RXFlush

  
PUB RX : btRX
{{
    ***PASSTHROUGH TO FullDuplexSerial OBJECT***
    Waits for a byte to exist in the RX buffer of the XBee and returns it
}}

  btRX := objXBee.RX

  
PUB TX (btTX)
{{
    ***PASSTHROUGH TO FullDuplexSerial OBJECT***
    Transmits a single byte via serial to the XBee
}}

  objXBee.TX (btTX)


PUB RXCheck : btRX
{{
    ***PASSTHROUGH TO FullDuplexSerial OBJECT***
    Checks for a byte in the RX buffer of the XBee
      if one exists, it is returned ($00..$FF)
      if not, long value of -1 is returned
}}

  btRX := objXBee.RXCheck


PUB TX_String (strTX)
{{
    ***PASSTHROUGH TO FullDuplexSerial OBJECT***
    Transmits a string via serial to the XBee
}}

  objXBee.str (strTX)